  l:  ;Spriteroutine f&uuml;r High Resolution (c) 1990 by Thomas Pl&uuml;mpe
  2:  ;Fr.-Ebert-Str. 25a. Pf. 107. 2000 Wedel. Tel. 04103/85556
  3:  ;Auf Clipping usw. wurde verzichtet, da diese Routine
  4:  ;lediglich als Beispiel zur geschwindigkeitsoptimierten
  5:  ;Programmierung dienen sollte.
  6:
  7: *** MAIN ***
  8:
  9:               bsr      init           ;Aufl&ouml;sung, etc.
 10: main:        bsr      in_shft        ;N&ouml;tige Sprites shiften
 12:              bsr.s    game           ;Sprite bewegen
 13:              clr.w     -(SP)         ;Programm
 15:              trap     #1             ;beenden
 16:
 17: *** main
 18:
 19: *** GAME ***
 20:
 21: game:        move.w   #624,D0
 22: game_lp:     lea      x_pos(PC),A0
 23:              move.w   D0,(A0)
 24:              move.w   D0,-(SP)       ;d0 retten
 25:
 26:              move.w   x_pos(PC),D0
 27;              move.w   y_pos(PC),Dl
 28:              lea      sprite(PC),AO
 29:              lea      mask(PC),A2
 30:              lea      sve_buf(PC),A3 ;wohin speichern ?
 31:              bsr.s    set_spr        ;Sprite setzen
 32:
 33:              move.w   #37,-(SP)      ;VSYNC
 34:              trap     #14
 35:              move.w   #$FF,-(SP)     ;optimierbar durch
 36:              move.w   #6,-(SP)       ;pea $000600ff !
 37:              trap     #1
 38:              addq.l   #6,SP          ;gemeinsame Stackkorrektur
 39:              tst.w    D0             ;Taste gedr&uuml;ckt ?
 40:              beq.s    go_on
 41:              addq.l   #2,SP          ;gerettetes dO
 42:              rts
 43: go_on:       lea      sve_buf(PC),A0
 44:              bsr.s    put_bck        ;Hintergrund zur&uuml;ck
 45:
 46:              move.w   (SP)+,D0       ;gerettetes dO zur&uuml;ck
 t7:              dbra     D0,game_lp
 48:              rts
 49:
 50: *** game
 51:
 52: **** PUT_BCK ***
 53:
 54: ;aO=Adresse des Buffers   Routine setzt Hintergrund zur&uuml;ck
 56: put_bck:     movea.l  (A0)+,A1
 57:              movem.l  (AO)+,D0-D7
 58:              move.l   DO,(A1)
 59:              move.l   D1,80(A1)
 60:              move.l   D2,160(A1)
 61:              move.l   D3,240(A1)
 62:              move.l   D4,320(A1)
 63:              move.l   D5,400(A1)
 64:              move.l   D6,480(A1)
 65:              move.l   D7,560(A1)
 66:              move.l   (AO)+,D0-D7
 67:              move.l   DO,640(A1)<!-- Seite 105, 1. Spalte -->
 68:              move.l   D1,720(A1)
 69:              move.l   D2,800(A1)
 70:              move.l   D3,880(A1)
 71:              move.l   D4,960(A1)
 72:              move.l   D5,1040(A1)
 73:              move.l   D6,1120(A1)
 74:              move.l   D7,1200(A1)
 75:              rts
 76:
 77: *** put_bck
 78:
 79:
 80: *** SET_SPR ***
 81:
 82: ;d0.w X-Position  d1.w Y-Position  a0.l Sprite  a2.l Mask
 83: ;a3.l Savebuffer
 84:
 85: set_spr:     lsl.w    #4,D1          ;mal 80, weil eine
 86:              move.w   D1,D2          ;Zeile 80 Bytes lang
 87:              add.w    D1,D1          ;ist schneller als
 88:              add.w    D1,D1          ;mulu !
 89:
 90:
 91:              move.w   D0,D2          ;X-Pos. in d2
 92:              lsr.w    #3,D0          ;welches Byte?
 93:              andi.b   #$FE,D0        ;gerade Adresse!
 94:              add.w    D0,D1          ;endg&uuml;ltige Pos. in d1
 95:              andi.w   #$0F,D2        ;welches Sprite?
 96:              lsl.w    #6,D2          ;mal Spritel&auml;nge (=64)
 97:              adda.w   D2,A0          ;a0 zeigt aufs Sprite
 98:              movea.l  screen(PC),A1  ;Logbase in a1
 99:              adda.w   D1,A1          ;a1 - welche Adresse?
100:              adda.w   D2,A2          ;a2 auf die Maskendaten
101:
102:              move.l   (A1),D0        ;Speicherung
103:              move.l   80(A1),D1      ;des Hinter-
104:              move.l   160(A1),D2     ;grundes
105:              move.l   240(A1),D3
106:              move.l   320(A1),D4
107:              move.l   400(A1),D5
108:              move.l   480(A1),D6
109:              move.l   560(A1),D7
110:              move.l   A1,(A3)+       ;als erstes die Adresse
111:              movem.l  D0-D7,(A3)
112:              move.l   640(A1),D0
113:              move.l   720(A1),D1
114:              move.l   800(A1),D2
115:              move.l   880(A1),D3
116:              move.l   960(A1),D4
117:              move.l   1040(A1),D5
118:              move.l   1120(A1),D6
119:              move.l   1200(A1),D7
120:              movem.l  D0-D7,32(A3)<!-- Seite 106, 1. Spalte -->
121:
122:              movem.l  (A2)+,D0-D7    ;Ausstanzen
123:              and.l    D0,(A1)        ;der Maske
124:              and.l    D1,80(A1)
125:              and.l    D2,160(A1)
126:              and.l    D3,240(A1)
127:              and.l    D4,320(A1)
128:              and.l    D5,400(A1)
129:              and.l    D6,480(A1)
130:              and.l    D7,560(A1)
131:              movem.l  (A2)+,D0-D7
132:              and.l    D0,640(A1)
133:              and.l    D1,720(A1)
134:              and.l    D2,800(A1)
135:              and.l    D3,880(A1)
136:              and.l    D4,960(A1)
137:              and.l    D5,1040(A1)
138:              and.l    D6,1120(A1)
139:              and.l    D7,1200(A1)
140:
141:              movem.l  (A0)+,D0-D/    ;Hineinkopieren
142:              or.l     D0,(A1)        ;der Daten
143:              or.l     D1,80(A1)
144:              or.l     D2,160(A1)
145:              or.l     D3,240(A1)
146:              or.l     D4,320(A1)
147:              or.l     D5,400(A1)
148:              or.l     D6,480(A1)
149:              or.l     D7,560(A1)
150:              movem.l  (A0)+,D0-D7
151:              or.l     D0,640(A1)
152:              or.l     D1,720(A1)
153:              or.l     D2,800(A1)
154:              or.l     D3,880(A1)
155:              or.l     D4,960(A1)
156:              or.l     D5,1040(A1)
157:              or.l     D6,1120(A1)
158:              or.l     D7,1200(A1)
159:              rts
160: *** set_spr
161:
162: *** SHIFT ***
163:
164: ;a0.l Sprite-Image  a1.l Platz f&uuml;r 16 Phasen
165: ;*Shiftet das Sprite a4.l Mask-Image
166: ;a5.l Platz f&uuml;r 16 Phasen  *in 16 Phasen
167:
168: shift:       moveq    #1,D2          ;2 Durchl&auml;ufe (Sprite/Maske)
169: s_twice:     moveq    #15,D1         ;16 Positionen
170:              movea.l  A1,A3          ;mit a3 arbeiten
171: s_copy1:     movea.l  A0,A2          ;mit a0 restaurieren
172:              moveq    #15,D0         ;16 Zeilen
173: s_copy:      move.w   (A2)+,(A3)+    ;Spriteposition kopieren <!-- Seite 106, 2. Spalte -->
174:              clr.w    (A3)+          ;0-Word f&uuml;r Rotation
175:              dbra     D0,s_copy      ;Schleife f&uuml;r 16 Zeilen
176:              dbra     D1,s_copy1     ;Schleife f&uuml;r 16 Spritepos.
177:              exg      A0,A4          ;jetzt die Maske (Daten)
178:              exg      A1,A5          ;jetzt die Maske (Buffer)
179:              dbra     D2,s_twice
180:              movea.l  A1,A3          ;wird unten gebraucht
181:
182:              moveq    #1,D4          ;2 Durchl&auml;ufe (Sprite/Maske)
183: s_twice1:    lea      64(A3),A3      ;Erstes Sprite bleibt
184:              moveq    #0,D2          ;wieviele Rotationen?
185:              moveq    #14,D3         ;alles bis auf eins
186: s_rot:       move.l   D2,D1          ;wieviele Rotationen?
187: s_rotate:    moveq    #15,D0         ;16 Zeilen rotieren
188: s_shift:     lsr.w    (A3)+          ;Eine Zeile
189:              roxr.w   (A3)+          ;rotieren
190:              dbra     D0,s_shift
191:              lea      -64(A3),A3     ;Sprite nochmal rotieren
192:              dbra     D1,s_rotate
193:              lea      64(A3),A3      ;n&auml;chstes Sprite
194:              addq.w   #1,D2          ;Eine Rotation mehr
195:              dbra     D3,s_rot
196:              movea.l  A5,A3          ;jetzt die Maske
197:              dbra     D4,s_twice1
198:
199:              movea.l  A5,A3          ;Maske mu&szlig; invertiert
200:              moveq    #127,D0        ;sein (h&auml;ngt mit den
201: s_invert:    not.l    (A3)+          ;Verkn&uuml;pfungsoperationen
202:              not.l    (A3)+          ;zusammen).
203:              dbra     D0,s_invert
204:              rts
204: *** shift
206:
207: *** IN_SHFT ***
208:
209: ;Hier werden alle ben&ouml;tigten Sprites geshiftet (hier eins):
210:
211: in_shft:     lea      sprite_img(PC),A0  ;Aussehen des Sprites
212:              lea      sprite(PC),A1      ;Buffer f&uuml;r 16 Phasen
213:              lea      mask_img(PC),A4    ;Aussehen der Maske
214:              lea      mask(PC),A5        ;Buffer f&uuml;r 16 Phasen
215:              bsr.s    shift
216:              rts
217: *** in_shft
218:
219: *** INIT ***
220: init:        DC.W $A00A              ;Maus aus
221:
222:              moveq    #-1,D0
223:              move.w   #2,-(SP)       ;Hi-Resolution
224:              move.l   D0,-(SP)       ;alte Log-
225:              move.l   D0,-(SP)       ;und Physbase
226:              move.w   #5,-(SP)       ;Setscreen <!-- Seite 107, 1. Spalte -->
227:              trap     #14            ;XBIOS
228:              lea      12(SP),SP      ;Stackkorrektur
229:
230:              move.w   #3,-(SP)       ;Get Logbase
231:              trap     #14            ;XBIOS
232:              addq.l   #2,SP          ;Stackkorrektur
233:              lea      screen(PC),A0  ;Adresse f&uuml;r die
234:              move.l   D0,(A0)        ;merken
235:
236:              move.l   #$A15FD6FE,D1  ;Hintergrund
237:              movea.l  D0,A0          ;Adresse der Logbase
238:              move.l   #7999,D0       ;8000 Longs
239: in_fill:     move.l   D1,A0          ;Adresse der Logbase
240:              dbra     D0,in_fill
241:              rts
242: *** init
243:              DATA
244: *** DATA ***
245: screen:      DS.L 1
246: x_pos:       DC.W 0
247: y_pos:       DC.W 100
248: mask_img:    DC.W $7FFE,$7FFE,$7FFE,$7C3E,$7C3E,$7C3E,$700E,$700E
249:              DC.W $700E,$700E,$7C3E,$7C3E,$7C3E,$7FFE,$7FFE,$7FFE
250: sprite_img:  DC.W %1111111111111110 ;Welch ein
251:              DC.W %1111111111111110 ;Kunstwerk...
252:              DC.W %1111111111111110 ;Spritegr&ouml;&szlig;e:
253:              DC.W %1110000000001110 ;16 mal 16 Pixel
254:              DC.W %1110000000001110
255:              DC.W %1110000000001110
256:              DC.W %1110000000001110
257:              DC.W %1110000000001110
258:              DC.W %1110000000001110
259:              DC.W %1110000000001110
260:              DC.W %1110000000001110
261:              DC.W %1110000000001110
262:              DC.W %1110000000001110
263:              DC.W %1111111111111110
264:              DC.W %1111111111111110
265:              DC.W %1111111111111110
266:
267: *** data
268:
269:              BSS
270:
271: *** BSS ***
272:
273: sprite:      DS.W 32*16        ;Sprite in 16 Phasen
274: mask:        DS.W 32*16        ;Maske in 16 Phasen
275: sve_buf:     DS.W 4+64         ;Adresse+Daten
276:
277: *** bss
278:
279:              END  
